--Copyright 1986-2017 Xilinx, Inc. All Rights Reserved.
----------------------------------------------------------------------------------
--Tool Version: Vivado v.2017.4 (win64) Build 2086221 Fri Dec 15 20:55:39 MST 2017
--Date        : Thu Mar 29 13:37:52 2018
--Host        : vinay-hdl running 64-bit Service Pack 1  (build 7601)
--Command     : generate_target fifos.bd
--Design      : fifos
--Purpose     : IP block netlist
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
entity fifos is
  port (
    fifo_to_fx3_empty : out STD_LOGIC;
    fifo_to_fx3_rd_data : out STD_LOGIC_VECTOR ( 31 downto 0 );
    fifo_to_fx3_rd_en : in STD_LOGIC;
    fifo_to_user_dvalid : out STD_LOGIC;
    fifo_to_user_empty : out STD_LOGIC;
    fifo_to_user_rd_data : out STD_LOGIC_VECTOR ( 31 downto 0 );
    fifo_to_user_rd_en : in STD_LOGIC;
    fx3_pclk : out STD_LOGIC;
    fx3_to_fifo_full : out STD_LOGIC;
    fx3_to_fifo_wr_data : in STD_LOGIC_VECTOR ( 31 downto 0 );
    fx3_to_fifo_wr_en : in STD_LOGIC;
    h2p_count : out STD_LOGIC_VECTOR ( 12 downto 0 );
    i_fx3_pclk : in STD_LOGIC;
    p2h_count : out STD_LOGIC_VECTOR ( 13 downto 0 );
    sys_clk : in STD_LOGIC;
    user_clk : out STD_LOGIC;
    user_to_fifo_almost_full : out STD_LOGIC;
    user_to_fifo_full : out STD_LOGIC;
    user_to_fifo_wr_data : in STD_LOGIC_VECTOR ( 31 downto 0 );
    user_to_fifo_wr_en : in STD_LOGIC
  );
  attribute CORE_GENERATION_INFO : string;
  attribute CORE_GENERATION_INFO of fifos : entity is "fifos,IP_Integrator,{x_ipVendor=xilinx.com,x_ipLibrary=BlockDiagram,x_ipName=fifos,x_ipVersion=1.00.a,x_ipLanguage=VHDL,numBlks=2,numReposBlks=2,numNonXlnxBlks=0,numHierBlks=0,maxHierDepth=0,numSysgenBlks=0,numHlsBlks=0,numHdlrefBlks=0,numPkgbdBlks=0,bdsource=USER,synth_mode=Global}";
  attribute HW_HANDOFF : string;
  attribute HW_HANDOFF of fifos : entity is "fifos.hwdef";
end fifos;

architecture STRUCTURE of fifos is
  component fifos_fpga_to_FX3_0 is
  port (
    wr_clk : in STD_LOGIC;
    rd_clk : in STD_LOGIC;
    din : in STD_LOGIC_VECTOR ( 31 downto 0 );
    wr_en : in STD_LOGIC;
    rd_en : in STD_LOGIC;
    dout : out STD_LOGIC_VECTOR ( 31 downto 0 );
    full : out STD_LOGIC;
    empty : out STD_LOGIC;
    valid : out STD_LOGIC;
    rd_data_count : out STD_LOGIC_VECTOR ( 12 downto 0 )
  );
  end component fifos_fpga_to_FX3_0;
  component fifos_fx3_to_FPGA_0 is
  port (
    wr_clk : in STD_LOGIC;
    rd_clk : in STD_LOGIC;
    din : in STD_LOGIC_VECTOR ( 31 downto 0 );
    wr_en : in STD_LOGIC;
    rd_en : in STD_LOGIC;
    dout : out STD_LOGIC_VECTOR ( 31 downto 0 );
    full : out STD_LOGIC;
    almost_full : out STD_LOGIC;
    empty : out STD_LOGIC;
    wr_data_count : out STD_LOGIC_VECTOR ( 13 downto 0 )
  );
  end component fifos_fx3_to_FPGA_0;
  signal FIFO_READ_1_1_EMPTY : STD_LOGIC;
  signal FIFO_READ_1_1_RD_DATA : STD_LOGIC_VECTOR ( 31 downto 0 );
  signal FIFO_READ_1_1_RD_EN : STD_LOGIC;
  signal FIFO_READ_1_EMPTY : STD_LOGIC;
  signal FIFO_READ_1_RD_DATA : STD_LOGIC_VECTOR ( 31 downto 0 );
  signal FIFO_READ_1_RD_EN : STD_LOGIC;
  signal FIFO_WRITE_1_1_FULL : STD_LOGIC;
  signal FIFO_WRITE_1_1_WR_DATA : STD_LOGIC_VECTOR ( 31 downto 0 );
  signal FIFO_WRITE_1_1_WR_EN : STD_LOGIC;
  signal FIFO_WRITE_1_ALMOST_FULL : STD_LOGIC;
  signal FIFO_WRITE_1_FULL : STD_LOGIC;
  signal FIFO_WRITE_1_WR_DATA : STD_LOGIC_VECTOR ( 31 downto 0 );
  signal FIFO_WRITE_1_WR_EN : STD_LOGIC;
  signal clk_wiz_0_clk_out1 : STD_LOGIC;
  signal fx3_FPGA_rd_data_count : STD_LOGIC_VECTOR ( 12 downto 0 );
  signal fx3_FPGA_valid : STD_LOGIC;
  signal fx3_to_FPGA_wr_data_count : STD_LOGIC_VECTOR ( 13 downto 0 );
  signal i_fx3_pclk_1 : STD_LOGIC;
  attribute X_INTERFACE_INFO : string;
  attribute X_INTERFACE_INFO of fifo_to_fx3_empty : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_fx3 EMPTY";
  attribute X_INTERFACE_INFO of fifo_to_fx3_rd_en : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_fx3 RD_EN";
  attribute X_INTERFACE_INFO of fifo_to_user_empty : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_user EMPTY";
  attribute X_INTERFACE_INFO of fifo_to_user_rd_en : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_user RD_EN";
  attribute X_INTERFACE_INFO of fx3_pclk : signal is "xilinx.com:signal:clock:1.0 CLK.FX3_PCLK CLK";
  attribute X_INTERFACE_PARAMETER : string;
  attribute X_INTERFACE_PARAMETER of fx3_pclk : signal is "XIL_INTERFACENAME CLK.FX3_PCLK, CLK_DOMAIN fifos_sys_clk, FREQ_HZ 100000000, PHASE 0.000";
  attribute X_INTERFACE_INFO of fx3_to_fifo_full : signal is "xilinx.com:interface:fifo_write:1.0 fx3_to_fifo FULL";
  attribute X_INTERFACE_INFO of fx3_to_fifo_wr_en : signal is "xilinx.com:interface:fifo_write:1.0 fx3_to_fifo WR_EN";
  attribute X_INTERFACE_INFO of i_fx3_pclk : signal is "xilinx.com:signal:clock:1.0 CLK.I_FX3_PCLK CLK";
  attribute X_INTERFACE_PARAMETER of i_fx3_pclk : signal is "XIL_INTERFACENAME CLK.I_FX3_PCLK, CLK_DOMAIN fifos_i_fx3_pclk, FREQ_HZ 100000000, PHASE 0.000";
  attribute X_INTERFACE_INFO of sys_clk : signal is "xilinx.com:signal:clock:1.0 CLK.SYS_CLK CLK";
  attribute X_INTERFACE_PARAMETER of sys_clk : signal is "XIL_INTERFACENAME CLK.SYS_CLK, CLK_DOMAIN fifos_sys_clk, FREQ_HZ 100000000, PHASE 0.000";
  attribute X_INTERFACE_INFO of user_clk : signal is "xilinx.com:signal:clock:1.0 CLK.USER_CLK CLK";
  attribute X_INTERFACE_PARAMETER of user_clk : signal is "XIL_INTERFACENAME CLK.USER_CLK, CLK_DOMAIN fifos_sys_clk, FREQ_HZ 100000000, PHASE 0.000";
  attribute X_INTERFACE_INFO of user_to_fifo_almost_full : signal is "xilinx.com:interface:fifo_write:1.0 user_to_fifo ALMOST_FULL";
  attribute X_INTERFACE_INFO of user_to_fifo_full : signal is "xilinx.com:interface:fifo_write:1.0 user_to_fifo FULL";
  attribute X_INTERFACE_INFO of user_to_fifo_wr_en : signal is "xilinx.com:interface:fifo_write:1.0 user_to_fifo WR_EN";
  attribute X_INTERFACE_INFO of fifo_to_fx3_rd_data : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_fx3 RD_DATA";
  attribute X_INTERFACE_INFO of fifo_to_user_rd_data : signal is "xilinx.com:interface:fifo_read:1.0 fifo_to_user RD_DATA";
  attribute X_INTERFACE_INFO of fx3_to_fifo_wr_data : signal is "xilinx.com:interface:fifo_write:1.0 fx3_to_fifo WR_DATA";
  attribute X_INTERFACE_INFO of user_to_fifo_wr_data : signal is "xilinx.com:interface:fifo_write:1.0 user_to_fifo WR_DATA";
begin
  FIFO_READ_1_1_RD_EN <= fifo_to_fx3_rd_en;
  FIFO_READ_1_RD_EN <= fifo_to_user_rd_en;
  FIFO_WRITE_1_1_WR_DATA(31 downto 0) <= fx3_to_fifo_wr_data(31 downto 0);
  FIFO_WRITE_1_1_WR_EN <= fx3_to_fifo_wr_en;
  FIFO_WRITE_1_WR_DATA(31 downto 0) <= user_to_fifo_wr_data(31 downto 0);
  FIFO_WRITE_1_WR_EN <= user_to_fifo_wr_en;
  clk_wiz_0_clk_out1 <= sys_clk;
  fifo_to_fx3_empty <= FIFO_READ_1_1_EMPTY;
  fifo_to_fx3_rd_data(31 downto 0) <= FIFO_READ_1_1_RD_DATA(31 downto 0);
  fifo_to_user_dvalid <= fx3_FPGA_valid;
  fifo_to_user_empty <= FIFO_READ_1_EMPTY;
  fifo_to_user_rd_data(31 downto 0) <= FIFO_READ_1_RD_DATA(31 downto 0);
  fx3_pclk <= clk_wiz_0_clk_out1;
  fx3_to_fifo_full <= FIFO_WRITE_1_1_FULL;
  h2p_count(12 downto 0) <= fx3_FPGA_rd_data_count(12 downto 0);
  i_fx3_pclk_1 <= i_fx3_pclk;
  p2h_count(13 downto 0) <= fx3_to_FPGA_wr_data_count(13 downto 0);
  user_clk <= clk_wiz_0_clk_out1;
  user_to_fifo_almost_full <= FIFO_WRITE_1_ALMOST_FULL;
  user_to_fifo_full <= FIFO_WRITE_1_FULL;
fpga_FX3: component fifos_fx3_to_FPGA_0
     port map (
      almost_full => FIFO_WRITE_1_ALMOST_FULL,
      din(31 downto 0) => FIFO_WRITE_1_WR_DATA(31 downto 0),
      dout(31 downto 0) => FIFO_READ_1_1_RD_DATA(31 downto 0),
      empty => FIFO_READ_1_1_EMPTY,
      full => FIFO_WRITE_1_FULL,
      rd_clk => i_fx3_pclk_1,
      rd_en => FIFO_READ_1_1_RD_EN,
      wr_clk => clk_wiz_0_clk_out1,
      wr_data_count(13 downto 0) => fx3_to_FPGA_wr_data_count(13 downto 0),
      wr_en => FIFO_WRITE_1_WR_EN
    );
fx3_FPGA: component fifos_fpga_to_FX3_0
     port map (
      din(31 downto 0) => FIFO_WRITE_1_1_WR_DATA(31 downto 0),
      dout(31 downto 0) => FIFO_READ_1_RD_DATA(31 downto 0),
      empty => FIFO_READ_1_EMPTY,
      full => FIFO_WRITE_1_1_FULL,
      rd_clk => clk_wiz_0_clk_out1,
      rd_data_count(12 downto 0) => fx3_FPGA_rd_data_count(12 downto 0),
      rd_en => FIFO_READ_1_RD_EN,
      valid => fx3_FPGA_valid,
      wr_clk => i_fx3_pclk_1,
      wr_en => FIFO_WRITE_1_1_WR_EN
    );
end STRUCTURE;
